#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <strings.h>
#include <stdio.h>
#include <malloc.h>
#include <ctype.h>
#include <stl.h>
#include <string>
#include <strstream>

#define DEB

#ifdef DEB
#define DEBUGN(x) cerr << x
#define DEBUG(x) cerr << x << endl
#else
#define DEBUG(x)
#define DEBUGN(x)
#endif

#define INPUT_FILE "smith.in"
#define PI (3.14159265359)

#define TRUE (0==0)
#define FALSE !TRUE

#define MAXINT (1<<30)
#define MININT -MAXINT

#define min(x,y) ((x<y)?x:y))
#define max(x,y) ((x>y)?x:y))

ifstream foo(INPUT_FILE);
istream &in = foo;

ostream& out=cout;

typedef long big;


big n;
big prims[100000];
int primIndex;
big zerl[100000];
int zerlIndex;


int qsum (big v) {
	big k = v;

	int i = 10;
	int sum = 0;
	int z = 0;
	int e = k % 10;
	
	if (v < 10) return v;

	for (i = 10; i <= v; i = i * 10) {
		k = k / 10;
		sum = sum + (k % 10);
	}

	return (e + sum);
}


int test () {
	int psum = 0;

	if (zerlIndex == 0) return false;

	for (int i = 0; i < zerlIndex; i++) {
		psum += qsum(zerl[i]);
	}

	int nsum = qsum(n);
	
	if (nsum == psum) return true;
	else return false;
}

void getZerl (big t) {
	big v;
	big k = t;
	int counter = 0;
	
	zerlIndex = 0;
	bzero (zerl, sizeof(zerl));

	while (TRUE) {

//		out << prims[counter] << endl;
	  if (counter > primIndex) break;
		v = k / prims[counter];
	  if ((v * prims[counter]) == k) {
		  k = v;
		  zerl[zerlIndex] = prims[counter];
		  zerlIndex++;
    }
	  else counter++;

	  if (k == 1) break;
	}
}

int isPrim (big t) {
	big v;

	for (int i = 0; i <= primIndex; i++) {
		//out << "isPrim: " << prims[i] << endl;

		v = t / prims[i];
		if ((v * prims[i]) == t) return false;
	}
	return true;
}

void getPrims (big k) {
	if (prims[primIndex] > k) {
		return;
	}
	else {
		big t = prims[primIndex] + 1;
		while (t <= ((k/2) + 1)) {
			if (isPrim(t)) {
				//out << prims[primIndex] << endl;
				primIndex++;
				prims[primIndex] = t;
				//out << primIndex << ": " << t << endl;
			}
			t++;
		}
	}
}

void calc() {
 big k = n + 1;

 while (true) {
  getPrims(k);
  getZerl(k);
  if (test()) {
   out << k << endl;
	 return;
  }
  k++;
 }
}

void main(char **argv, int argc) {
 primIndex = 0;
 bzero(prims, sizeof(prims));
 prims[0] = 2;

 while (true) {
  in >> n;
  if (n == 0) break;
//	if (n == 1) {
//		out << n << endl;
//	}
//  else calc();
	calc();
 }
}









