#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <strings.h>
#include <stdio.h>
#include <malloc.h>
#include <ctype.h>
#include <string>
#include <strstream>

#define DEB

#ifdef DEB
#define DEBUGN(x) cerr << x
#define DEBUG(x) cerr << x << endl
#else
#define DEBUG(x)
#define DEBUGN(x)
#endif

#define INPUT_FILE "atlantis.in"
#define PI (3.14159265359)

#define TRUE (0==0)
#define FALSE !TRUE

#define MAXINT (1<<30)
#define MININT -MAXINT

#define min(x,y) ((x<y)?x:y)
#define max(x,y) ((x>y)?x:y)

ifstream foo(INPUT_FILE);
istream &in = foo;

ostream& out=cout;

typedef struct _rect {
  double x1, x2;
  double y1, y2;
} rect;

int N;
rect map[101];


double flaeche (rect r) {
	double w = r.x2 - r.x1;
	double h = r.y2 - r.y1;

	return (w * h);
}


double getArea (int i, int stepsize) {
	double area = 0.0;
	rect r;

	r.x1 = map[i].x1;
	r.x2 = map[i].x2;
	r.y1 = map[i].y1;
	r.y2 = map[i].y2;

	area = flaeche(r);

	if (stepsize == 1) return area;

	for (int k = 1; k < stepsize; k++) {
		if (map[k].x1 > r.x2) return 0.0;
		if (map[k].x2 < r.x1) return 0.0;
		if (map[k].y1 > r.y2) return 0.0;
		if (map[k].y2 < r.y1) return 0.0;

		r.x1 = max(map[k].x1, r.x1);
		r.x2 = min(map[k].x2, r.x2);
		r.y1 = max(map[k].y1, r.y1);
		r.y2 = min(map[k].y2, r.y2);
	}

	return (flaeche(r));
}


double calc() {
	int factor = 1;
	double flaeche = 0.0;

	for (int stepsize = 1; stepsize <= N; stepsize++) {
		for (int i = 0; i < N; i+=stepsize) {
			flaeche = flaeche + (factor) * getArea(i, stepsize);
		}
		factor = factor * (-1);
	}

	return flaeche;
}

void main(char **argv, int argc) {
	int c = 0;

	while (true) {
		bzero(map, sizeof(map));
		in >> N;
		if (N == 0) break;
		for (int i = 0; i < N; i++) {
			in >> map[i].x1;
			in >> map[i].y1;
			in >> map[i].x2;
			in >> map[i].y2;
		}

		out << "Test case #" << ++c << endl;
		out << "Total explored area: ";
		out.precision(2);
		out.setf(ios::fixed, ios::floatfield);
		out << calc() << endl;
		out << endl;
	}
}
